package dev.shadowsoffire.apotheosis.ench.enchantments.corrupted;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.adventure.compat.AdventureCuriosCompat;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.util.Mth;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentCategory;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraftforge.common.ToolActions;
import net.minecraftforge.event.entity.living.LivingHealEvent;
import net.minecraftforge.fml.ModList;

public class LifeMendingEnchant extends Enchantment {
  public LifeMendingEnchant() {
    super(Enchantment.Rarity.VERY_RARE, EnchantmentCategory.BREAKABLE, EquipmentSlot.values());
  }
  
  public int m_6183_(int level) {
    return 65 + (level - 1) * 35;
  }
  
  public int m_6175_(int level) {
    return m_6183_(level) + 50;
  }
  
  public int m_6586_() {
    return 3;
  }
  
  public boolean m_6589_() {
    return true;
  }
  
  public boolean canApplyAtEnchantingTable(ItemStack stack) {
    return (super.canApplyAtEnchantingTable(stack) || stack.canPerformAction(ToolActions.SHIELD_BLOCK));
  }
  
  protected boolean m_5975_(Enchantment pOther) {
    return (super.m_5975_(pOther) && pOther != Enchantments.f_44962_);
  }
  
  public Component m_44700_(int level) {
    return (Component)((MutableComponent)super.m_44700_(level)).m_130940_(ChatFormatting.DARK_RED);
  }
  
  private static final EquipmentSlot[] SLOTS = EquipmentSlot.values();
  
  private boolean lifeMend(LivingHealEvent e, ItemStack stack) {
    if (!stack.m_41619_() && stack.m_41768_()) {
      int level = stack.getEnchantmentLevel(this);
      if (level <= 0)
        return false; 
      float cost = 1.0F / (1 << level - 1);
      int maxRestore = Math.min(Mth.m_14143_(e.getAmount() / cost), stack.m_41773_());
      e.setAmount(e.getAmount() - maxRestore * cost);
      stack.m_41721_(stack.m_41773_() - maxRestore);
      return true;
    } 
    return false;
  }
  
  public void lifeMend(LivingHealEvent e) {
    if ((e.getEntity().m_9236_()).f_46443_)
      return; 
    float amt = e.getAmount();
    if (amt <= 0.0F)
      return; 
    for (EquipmentSlot slot : SLOTS) {
      ItemStack stack = e.getEntity().m_6844_(slot);
      if (lifeMend(e, stack))
        return; 
    } 
    if (ModList.get().isLoaded("curios")) {
      List<ItemStack> stacks = AdventureCuriosCompat.getLifeMendingCurios(e.getEntity());
      for (ItemStack stack : stacks) {
        if (lifeMend(e, stack))
          return; 
      } 
    } 
  }
}
